Summary: An X Window System based version of GNU Emacs.
Name: xemacs
%define version 21.1.2
%define REALVER 21.1-p2
Version: %{version}
Release: 1
Copyright: GPL
Group: Applications/Editors
Source0: ftp://ftp.xemacs.org/pub/xemacs/xemacs-%{version}/xemacs-%{version}.tar.gz
Source1: ftp://ftp.xemacs.org/pub/xemacs/packages/xemacs-sumo-1999-05-13.tar.gz
Source2: ftp://ftp.xemacs.org/pub/xemacs/packages/xemacs-mule-sumo-1999-05-13.tar.gz
Source5: xemacs-README.i386-pc-linux
Source6: xemacs.desktop
Url: http://www.xemacs.org/
Buildroot: /var/tmp/xemacs-root
Requires: ctags
ExcludeArch: alpha

%description
XEmacs (and regular GNU Emacs, too) is a self-documenting,
customizable, extensible, real-time display editor.  XEmacs is
self-documenting because at any time you can type in control-h to
find out what your options are or to find out what a command does.
XEmacs is customizable because you can change the definitions of XEmacs
commands to anything you want.  XEmacs is extensible because you can
write entirely new commands--programs in the Lisp language to be run by
Emacs' own Lisp interpreter.  XEmacs includes a real-time display, which
means that the text being edited is visible on the screen and is updated
very frequently (usually after every character or pair of characters)
as you type.

This XEmacs distribution consists of four rpms: xemacs-21.0.67 (the main
portion, including the standard XEmacs binary which most people use),
xemacs-el-21.0.67 (elisp sources, which you only need if you're going to
program with Lisp in XEmacs), xemacs-info-21.0.67 (optional information
about XEmacs), and xemacs-extras-21.0.67 (files in common with Emacs,
which you must install if you're installing XEmacs and you do not have
Emacs installed).

To use XEmacs, you'll need to install the XEmacs binary.  The xemacs
package includes the standard XEmacs binary that most people will use.
The XEmacs binary is dynamically linked, with both X11 and TTY (ncurses)
support, but without mule (MUlti-Lingual Emacs, the Asian character set)
support. 

You might be able to tailor XEmacs to your use by using one of the
following packages instead of xemacs: xemacs-static (static link with
X11, ncurses, NO mule), xemacs-X11 (dynamic link with X11, NO ncurses,
NO mule), xemacs-mule (dynamic link with X11, NO ncurses, mule) or
xemacs-nox (dynamic link with NO X11, ncurses, NO mule).

In order to use XEmacs, you will have to install either xemacs OR one of
the four choices listed above (xemacs-static, xemacs-X11, xemacs-mule,
xemacs-nox).  Check each of the individual package descriptions if you
want more information.  You will also need to install xemacs-extras, if
you do not have GNU Emacs already installed.

%package el
Summary: The .el source files for XEmacs.
Group: Applications/Editors
Requires: xemacs = %{version}
%description el
Xemacs-el is not necessary to run XEmacs.  You'll only need to install
it if you're planning on incorporating some Lisp programming into your
XEmacs experience.

%package info
Summary: Information files for XEmacs.
Group: Applications/Editors
Requires: xemacs = %{version}
%description info
Install this package if you want the information files that are
distributed with the XEmacs text editor.

%package static
Summary: A statically linked XEmacs.
Group: Applications/Editors
Requires: xemacs = %{version}
%description static
Install this version of the xemacs binary (instead of the standard
XEmacs binary included in the xemacs package) if you need an XEmacs
binary that is independent of the libraries installed. Xemacs-static
compiles with X11 and TTY (ncurses) support, but without mule
(MUlti-Lingual Emacs - Asian character set) support.
 
If you do not already have GNU Emacs installed, you will also need to
install the xemacs-extras package.

%package extras
Summary: Files that XEmacs has in common with GNU Emacs.
Group: Applications/Editors
Requires: xemacs = %{version}
Conflicts: emacs
%description extras
Xemacs-extras includes files which are used by both GNU Emacs
and XEmacs. If you don't have GNU Emacs installed, be sure to also
install this package when you install the XEmacs text editor.

%package mule
Summary: The XEmacs binary with mule (MUlti-Lingual Emacs) support.
Group: Applications/Editors
Requires: xemacs = %{version}
%description mule
Xemacs-mule includes an XEmacs binary with support for
MUlti-Lingual Emacs and the Asian character set. Install xemacs-mule
(instead of xemacs) if you need to use Asian characters. Xemacs-mule is
compiled with X11 support only, so you won't be able to use it in a TTY
(ncurses) mode.

%package noX
Summary: An XEmacs binary without X11 support.
Group: Applications/Editors
Requires: xemacs = %{version}
%description noX
Xemacs-nox includes an XEmacs binary which will run XEmacs in console
mode (with an ncurses interface). If you happen to like the XEmacs
feature set a lot, but you either don't like X11 or can't use X11 all the
time, this binary (instead of the standard XEmacs binary included in the
xemacs package) is for you. It is *much* lighter than the standard X11
version of XEmacs, so you can enjoy a faster and smaller XEmacs.

If you do not have GNU Emacs installed, you will also need to install the
xemacs-extras package.

%package X11
Summary: The XEmacs binary without ncurses support.
Group: Applications/Editors
Requires: xemacs = %{version}
%description X11
Xemacs-X11 includes an XEmacs binary you'll want to use instead of
the binary included in the xemacs package, if you don't ever run
XEmacs on the standard console (the ncurses interface). The advantage
is that if you don't have the TTY support compiled in, you'll save some
memory.

%prep
%define _fixgroup [ `id -u` = '0' ] && chgrp -Rf root . || :
%setup -q 
rm -f xemacs-packages

%build
for flag in $RPM_ARCH-redhat-linux \
	--with-gnu-make \
	--with-gpm=no \
	--with-sound=none \
	--with-pop --mail-locking=flock \
	--with-clash-detection \
	--debug=no --error-checking=none \
	--prefix=/usr --lockdir=/var/lock/xemacs \
	; do
XEMACS_CONFIG="$XEMACS_CONFIG $flag"
done
CFLAGS="$RPM_OPT_FLAGS"
export CFLAGS

rm -rf building
mkdir building
cd building

# standard: X11 and console support. No mule, though.
{
rm -rf $RPM_ARCH-linux
mkdir $RPM_ARCH-linux
cd $RPM_ARCH-linux
../../configure $XEMACS_CONFIG --with-x11 \
	--with-dialogs=athena3d \
	--with-scrollbars=lucid --with-menubars=lucid \
	--with-xpm --with-xface \
	--with-mule=no --dynamic=yes \
	--with-tty=yes --with-ncurses
cd ..
}

# This is crazy, but it works...

# X11 support only
{
rm -rf $RPM_ARCH-linux-X11
mkdir -p $RPM_ARCH-linux-X11
cd $RPM_ARCH-linux-X11
../../configure $XEMACS_CONFIG --with-x11 --with-tty=no \
	--with-dialogs=athena3d \
	--with-scrollbars=lucid --with-menubars=lucid \
	--with-xpm --with-xface --dynamic=yes \
	--with-mule=no
cat >> Makefile <<EOF

variant: \${GENERATED_HEADERS} \${MAKE_SUBDIR}
EOF
cd ..
}

# X11 and mule support. Mule in console is extremely lame, so we leave the
# console out
{
rm -rf $RPM_ARCH-linux-mule
mkdir -p $RPM_ARCH-linux-mule
cd $RPM_ARCH-linux-mule
../../configure $XEMACS_CONFIG --with-x11 --with-tty=no \
	--with-dialogs=athena3d \
	--with-scrollbars=lucid --with-menubars=lucid \
	--with-xpm --with-xface --dynamic=yes \
	--with-mule=yes
cat >> Makefile <<EOF

variant: \${GENERATED_HEADERS} \${MAKE_SUBDIR}
EOF
cd ..
}

# X11, static version (why do we need this ?!)
# we leave the tty support in - now talk about a bloated static
# executable....:-(. Also, we sacrifice mule users. Sorry :-(
{
rm -rf $RPM_ARCH-linux-static
mkdir -p $RPM_ARCH-linux-static
cd $RPM_ARCH-linux-static
../../configure $XEMACS_CONFIG --with-x11 \
	--with-dialogs=athena3d \
	--with-scrollbars=lucid --with-menubars=lucid \
	--with-xpm --with-xface \
	--with-tty=yes --with-ncurses --dynamic=no \
	--with-mule=no
cat >> Makefile <<EOF

variant: \${GENERATED_HEADERS} \${MAKE_SUBDIR}
EOF
cd ..
}

# noX version - no X support, just the console
{
rm -rf $RPM_ARCH-linux-noX
mkdir -p $RPM_ARCH-linux-noX
cd $RPM_ARCH-linux-noX
../../configure $XEMACS_CONFIG --with-x11=no \
	--with-tty=yes --with-ncurses \
	--with-mule=no --dynamic=yes
cat >> Makefile <<EOF

variant: \${GENERATED_HEADERS} \${MAKE_SUBDIR}
EOF
cd ..
}

# Now we build everything. Don't you *love* fast build machines ?
make -C $RPM_ARCH-linux ldflags="-L/usr/X11R6/lib"
make -C $RPM_ARCH-linux-noX variant ldflags=""
make -C $RPM_ARCH-linux-static variant ldflags="-static -L/usr/X11R6/lib"
make -C $RPM_ARCH-linux-X11 variant ldflags="-L/usr/X11R6/lib"
make -C $RPM_ARCH-linux-mule variant ldflags="-L/usr/X11R6/lib"

%install
rm -rf $RPM_BUILD_ROOT
cd building
make install \
	prefix=$RPM_BUILD_ROOT/usr \
	lockdir=$RPM_BUILD_ROOT/var/lock/xemacs -C $RPM_ARCH-linux
for i in static X11 mule noX ; do 
	install -m 755 $RPM_ARCH-linux-$i/src/xemacs $RPM_BUILD_ROOT/usr/bin/xemacs-$i
done
cd ..
cp %{SOURCE5} README.i386-pc-linux
mkdir -p $RPM_BUILD_ROOT/usr/lib/xemacs
tar -xzf %{SOURCE1} -C $RPM_BUILD_ROOT/usr/lib/xemacs
tar -xzf %{SOURCE2} -C $RPM_BUILD_ROOT/usr/lib/xemacs
mkdir -p $RPM_BUILD_ROOT/usr/lib/xemacs/site-packages
find $RPM_BUILD_ROOT/usr/lib/xemacs/xemacs-packages -name \*.pl -exec \
    perl -pi -e "s|/usr/local/bin/perl5|/usr/bin/perl|g; \
		 s|/usr/local/bin/perl|/usr/bin/perl|g;" {} \;

# Build file listings. (and make movemail setgid mail on RHL)
DIR="$RPM_BUILD_ROOT/usr/lib/xemacs-%{REALVER}"
PACKAGES=$RPM_BUILD_ROOT/usr/lib/xemacs/xemacs-packages
MULEDIR=$RPM_BUILD_ROOT/usr/lib/xemacs/mule-packages
INFO="*.info*"
EL="*.el"

find $DIR -type d |
  sed -e "s#^$RPM_BUILD_ROOT#%dir #g" > rpm-files

find $DIR $PACKAGES -name $INFO -type f |
  sed -e "s#^$RPM_BUILD_ROOT##g" > rpm-info-files

find $DIR $PACKAGES $MULEDIR -not -name $INFO -name $EL -type f |
  sed -e "s#^$RPM_BUILD_ROOT##g" > rpm-el-files

find $DIR $PACKAGES -not -name $INFO -not -name $EL -type f |
  sed -e "
    s#^$RPM_BUILD_ROOT\(.*movemail\)#%attr(2755, root, mail) \1#g
    s#^$RPM_BUILD_ROOT##g
  " >> rpm-files

find $MULEDIR -not -name $EL -type f |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) #g" > rpm-mule-files

install -m 755 -d $RPM_BUILD_ROOT/etc/X11/applnk/Editors/
install -m 644 -o root -g root $RPM_SOURCE_DIR/xemacs.desktop $RPM_BUILD_ROOT/etc/X11/applnk/Editors/

%files -f rpm-files
%defattr(-,  root, root)
%config /etc/X11/applnk/Editors/
%doc INSTALL README COPYING GETTING.GNU.SOFTWARE PROBLEMS CHANGES-beta
%doc etc/NEWS etc/MAILINGLISTS BUGS README.i386-pc-linux README.packages
%doc etc/TUTORIAL
%config /usr/bin/xemacs
/usr/bin/xemacs-%{REALVER}
/usr/bin/pstogif
/usr/bin/gnuclient
/usr/bin/gnuattach
/usr/bin/gnudoit
/usr/man/man1/xemacs.1
/usr/man/man1/gnuserv.1
/usr/man/man1/gnuclient.1
/usr/man/man1/gnuattach.1
/usr/man/man1/gnudoit.1
%dir /var/lock/xemacs
%dir /usr/lib/xemacs
%dir /usr/lib/xemacs/xemacs-packages
%dir /usr/lib/xemacs/site-packages

%files el -f rpm-el-files
%defattr(-, root, root)

%files info -f rpm-info-files
%defattr(-, root, root)

%files extras
%defattr(-, root, root)
/usr/bin/b2m
/usr/bin/etags
/usr/bin/rcs-checkin
/usr/man/man1/etags.1

%files static
/usr/bin/xemacs-static

%files noX
%defattr(-, root, root)
/usr/bin/xemacs-noX

%files mule -f rpm-mule-files
%defattr(-, root, root)
/usr/bin/xemacs-mule
%dir /usr/lib/xemacs/mule-packages

%files X11
%defattr(-, root, root)
/usr/bin/xemacs-X11

%clean
rm -rf $RPM_BUILD_ROOT
rm -f rpm-files
rm -f rpm-info-files
rm -f rpm-el-files
rm -f rpm-mule-files

%changelog
* Fri May 14 1999 Cristian Gafton <gafton@redhat.com>
- version 21.1.2
- require ctags

* Wed Oct 14 1998 Michael Maher <mike@redhat.com>
- built pacakge for 5.2, didn't use a pre update. 

* Sat Apr 11 1998 Cristian Gafton <gafton@redhat.com>
- updated to 20.4
- new package xemacs-mule with mule support
- Changed spec file almost completely

* Fri Dec  5 1997 Otto Hammersmith <otto@redhat.com>
- refixed perl problem.
- added wmconfig

* Tue Dec  2 1997 Otto Hammersmith <otto@redhat.com>
- added changelog
- configure for ncurses
- removed sound support on i386
- moved buildroot to /var/tmp
